### The "STTY" package

This package provides simplified way to invoke **stty** utility to perform some
tasks by means of it. For now the only a few number of functions are implemented:
set tty baudrate, check tty baudrate and test if selected baudrate is available
for some tty. 

-------------

### Usage
1. Download the package by **go get** command:
```shell
go get code.foilhatguy.casa/pub/stty
```

2. Import package to your golang code:
```go
import (
	"code.foilhatguy.casa/pub/stty"
)
```

3. Create new stty object by means of **Get()** function:
```go
    sttyControl, err := stty.Get()
```

If **stty** is unavailable at the current system this function will
return an error.

4. Use stty object to perform some tasks. For instance, test if baudrate of 9600
is available at **/dev/ttyUSB0**: 
```go
    ok, err := sttyControl.TestBaudRate("/dev/ttyUSB0", 9600)
```